/*
 *  Copyright (C) 2006-2007 Daniel Bessler <danielb@kiba-dock.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 *  Author : Daniel Bessler <danielb@kiba-dock.org>
*/

#ifndef __KIBA_MENU_H__
#define __KIBA_MENU_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define KIBA_TYPE_MENU           (kiba_menu_get_type ())
#define KIBA_MENU(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), KIBA_TYPE_MENU, KibaMenu))
#define KIBA_MENU_CLASS(obj)     (G_TYPE_CHECK_CLASS_CAST ((obj), KIBA_MENU,  KibaMenuClass))
#define KIBA_IS_MENU(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KIBA_TYPE_MENU))
#define KIBA_IS_MENU_CLASS(obj)  (G_TYPE_CHECK_CLASS_TYPE ((obj), KIBA_TYPE_MENU))
#define KIBA_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KIBA_TYPE_MENU, KibaMenuClass))

typedef struct _KibaMenu       KibaMenu;
typedef struct _KibaMenuClass  KibaMenuClass;

struct _KibaMenu {
	GtkMenu  parent_instance;
};

struct _KibaMenuClass {
	GtkMenuClass  parent_class;
};

/**
 * Creates and returns a KibaMenu Instance.
 *
 * @return The KibaMenu Instance created.
 */
GtkWidget* kiba_menu_new (void);

G_END_DECLS

#endif
